<template>
  <div class="container">
    <div class="py-3">
      <h4>
        <router-link
          class="text-reset text-decoration-none"
          :to="{ name: 'home' }"
        >
          Home
        </router-link>
        /
        <router-link
          class="text-reset text-decoration-none"
          :to="{ name: 'campaign' }"
        >
          All Campaign
        </router-link>
        / {{  campaign.title }}
      </h4>
    </div>
    <div v-if="loading" class="text-center" colspan="5 ">
      <div class="spinner-border" role="status">
        <span class="visually-hidden">Loading...</span>
      </div>
    </div>
    <div class="card" v-if="!loading">
      <div class="card-body">
        <div class="row g-0">
          <div class="col-md-4 px-2">
            <img
            :src="campaign.image ? 'http://localhost:8000/'+ campaign.image : 'https://dummyimage.com/16:9x1080'"
              class="card-img-top"
              width="400px"
              alt="..."
            />
          </div>

          <div class="col-sm-6 col-md-8 px-2">
            <h3 class="pt-3">
              <b>{{ campaign.title }}</b>
            </h3>
            <p class="card-text">{{ campaign.description }}</p>

            <div class="mb-3">
              <table class="table">
                <tbody>
                  <tr>
                    <td><h5>Tekumpul</h5></td>
                    <td>
                      <h5 style="color: orange">
                        {{ formatPrice(campaign.total_donate) }}
                      </h5>
                    </td>
                  </tr>
                  <tr>
                    <td><h5>Dibutuhkan</h5></td>
                    <td>
                      <h5 style="color: green">
                        {{ formatPrice(campaign.donate_required) }}
                      </h5>
                    </td>
                  </tr>
                </tbody>
              </table>
            </div>
          </div>

          <div class="d-grid gap-2 mt-3">
            <button
              class="btn btn-secondary btn:sm"
              style="background-color: #00686B"
              @click="donate"
              :disabled="campaign.total_donate >= campaign.donate_required"
            >
              Donate
            </button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapMutations, mapGetters } from "vuex";

export default {
  props: ["slug", "countState"],
  data() {
    return {
      url: "http://localhost:8000",
      loading: false,
      donateAlert: false,
      campaign: [],
    };
  },
  computed: {
    ...mapGetters({
      transactions: "auth/transactions",
      user: "auth/user",
      guest: "auth/guest",
      alert: "alert/alert",

      alertText: "alert/alertText",
    }),
  },

  methods: {
    getCampaign: function () {
      this.loading = true;
      const config = {
        methods: "get",
        url: this.url + "/api/Campaign/show-campaign/" + this.slug.toString(),
      };
      axios(config)
        .then((response) => {
          this.campaign = response.data.campaign;
          this.loading = false;
        })
        .catch((error) => {
          console.log(error);
        });
    },
    formatProgress(total_donate, donate_required) {
      let val = (total_donate / donate_required) * 100;
      return val.toFixed(0);
    },

    formatPrice(value) {
      let val = value / 1;
      return "Rp " + val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
    },

    ...mapMutations({
      insert: "transaction/insert",
      getAlert: "alert/getAlert",
      getAlertError: "alert/getAlertError",
      closeAlert: "alert/closeAlert",
    }),

    donate() {
      if (!this.guest) {
        this.getAlert("Donasi Berhasil");
        this.insert(1);
      } else {
          this.getAlertError("Silahkan Login Terlebih dahulu Sebelum Melakukan Donasi")
        // this.$router.push("/Login");
      }
    },

    // donate(){
    //     this.$store.commit('insert')
    // }
  },

  created() {
    this.getCampaign();
  },
};
</script>
